
/*
 *
 * Copyright (c) 2002, NVIDIA Corporation.
 * 
 *  
 * 
 * NVIDIA Corporation("NVIDIA") supplies this software to you in consideration 
 * of your agreement to the following terms, and your use, installation, 
 * modification or redistribution of this NVIDIA software constitutes 
 * acceptance of these terms.  If you do not agree with these terms, please do 
 * not use, install, modify or redistribute this NVIDIA software.
 * 
 *  
 * 
 * In consideration of your agreement to abide by the following terms, and 
 * subject to these terms, NVIDIA grants you a personal, non-exclusive license,
 * under NVIDIAs copyrights in this original NVIDIA software (the "NVIDIA 
 * Software"), to use, reproduce, modify and redistribute the NVIDIA 
 * Software, with or without modifications, in source and/or binary forms; 
 * provided that if you redistribute the NVIDIA Software, you must retain the 
 * copyright notice of NVIDIA, this notice and the following text and 
 * disclaimers in all such redistributions of the NVIDIA Software. Neither the 
 * name, trademarks, service marks nor logos of NVIDIA Corporation may be used 
 * to endorse or promote products derived from the NVIDIA Software without 
 * specific prior written permission from NVIDIA.  Except as expressly stated 
 * in this notice, no other rights or licenses express or implied, are granted 
 * by NVIDIA herein, including but not limited to any patent rights that may be 
 * infringed by your derivative works or by other works in which the NVIDIA 
 * Software may be incorporated. No hardware is licensed hereunder. 
 * 
 *  
 * 
 * THE NVIDIA SOFTWARE IS BEING PROVIDED ON AN "AS IS" BASIS, WITHOUT 
 * WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING 
 * WITHOUT LIMITATION, WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR ITS USE AND OPERATION 
 * EITHER ALONE OR IN COMBINATION WITH OTHER PRODUCTS.
 * 
 *  
 * 
 * IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL, 
 * EXEMPLARY, CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, LOST 
 * PROFITS; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
 * PROFITS; OR BUSINESS INTERRUPTION) OR ARISING IN ANY WAY OUT OF THE USE, 
 * REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE NVIDIA SOFTWARE, 
 * HOWEVER CAUSED AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING 
 * NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN IF NVIDIA HAS BEEN ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */ 


/* 
 * The following macro invocations define the supported CG basic hardware 
 * bind locations.
 *
 * The macros have the form :
 *
 *   CG_BINDLOCATION_MACRO(name, compiler_name, enum_int)
 *
 *     name          : The name of the location.
 *     compiler_name : The name of the location within the compiler syntax.
 *     int_id        : Integer enumerant associated with this bind location.
 *     addressable   : The bind location must have an integer address 
 *                     associated with it.
 *     ParamType     : the cgParamType of this register. 
 *   
 */


CG_BINDLOCATION_MACRO(TexUnit0,"texunit 0",0,0,cgTexObjParam)
CG_BINDLOCATION_MACRO(TexUnit1,"texunit 1",1,0,cgTexObjParam)
CG_BINDLOCATION_MACRO(TexUnit2,"texunit 2",2,0,cgTexObjParam)
CG_BINDLOCATION_MACRO(TexUnit3,"texunit 3",3,0,cgTexObjParam)
CG_BINDLOCATION_MACRO(TexUnit4,"texunit 4",4,0,cgTexObjParam)
CG_BINDLOCATION_MACRO(TexUnit5,"texunit 5",5,0,cgTexObjParam)
CG_BINDLOCATION_MACRO(TexUnit6,"texunit 6",6,0,cgTexObjParam)
CG_BINDLOCATION_MACRO(TexUnit7,"texunit 7",7,0,cgTexObjParam)

CG_BINDLOCATION_MACRO(Attr0,"ATTR0",8,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr1,"ATTR1",9,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr2,"ATTR2",10,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr3,"ATTR3",11,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr4,"ATTR4",12,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr5,"ATTR5",13,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr6,"ATTR6",14,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr7,"ATTR7",15,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr8,"ATTR8",16,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr9,"ATTR9",17,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr10,"ATTR10",18,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr11,"ATTR11",19,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr12,"ATTR12",20,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr13,"ATTR13",21,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr14,"ATTR14",22,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Attr15,"ATTR15",23,0,cgConnectorMemberParam)

CG_BINDLOCATION_MACRO(VertUniform,"c",24,1,cgUniformParam)

CG_BINDLOCATION_MACRO(Tex0,"TEX0",25,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Tex1,"TEX1",26,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Tex2,"TEX2",27,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Tex3,"TEX3",28,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Tex4,"TEX4",29,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Tex5,"TEX5",30,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Tex6,"TEX6",31,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Tex7,"TEX7",32,0,cgConnectorMemberParam)

CG_BINDLOCATION_MACRO(HPos,"HPOS",33,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Col0,"COL0",34,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Col1,"COL1",35,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Col,"COL",36,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Col2,"COL2",37,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(Col3,"COL3",38,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(PSiz,"PSIZ",39,0,cgConnectorMemberParam)
CG_BINDLOCATION_MACRO(WPos,"WPOS",40,0,cgConnectorMemberParam)

#undef CG_BINDLOCATION_MACRO
