/*
 *
 * Copyright (c) 2002, NVIDIA Corporation.
 * 
 *  
 * 
 * NVIDIA Corporation("NVIDIA") supplies this software to you in consideration 
 * of your agreement to the following terms, and your use, installation, 
 * modification or redistribution of this NVIDIA software constitutes 
 * acceptance of these terms.  If you do not agree with these terms, please do 
 * not use, install, modify or redistribute this NVIDIA software.
 * 
 *  
 * 
 * In consideration of your agreement to abide by the following terms, and 
 * subject to these terms, NVIDIA grants you a personal, non-exclusive license,
 * under NVIDIAs copyrights in this original NVIDIA software (the "NVIDIA 
 * Software"), to use, reproduce, modify and redistribute the NVIDIA 
 * Software, with or without modifications, in source and/or binary forms; 
 * provided that if you redistribute the NVIDIA Software, you must retain the 
 * copyright notice of NVIDIA, this notice and the following text and 
 * disclaimers in all such redistributions of the NVIDIA Software. Neither the 
 * name, trademarks, service marks nor logos of NVIDIA Corporation may be used 
 * to endorse or promote products derived from the NVIDIA Software without 
 * specific prior written permission from NVIDIA.  Except as expressly stated 
 * in this notice, no other rights or licenses express or implied, are granted 
 * by NVIDIA herein, including but not limited to any patent rights that may be 
 * infringed by your derivative works or by other works in which the NVIDIA 
 * Software may be incorporated. No hardware is licensed hereunder. 
 * 
 *  
 * 
 * THE NVIDIA SOFTWARE IS BEING PROVIDED ON AN "AS IS" BASIS, WITHOUT 
 * WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING 
 * WITHOUT LIMITATION, WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR ITS USE AND OPERATION 
 * EITHER ALONE OR IN COMBINATION WITH OTHER PRODUCTS.
 * 
 *  
 * 
 * IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL, 
 * EXEMPLARY, CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, LOST 
 * PROFITS; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
 * PROFITS; OR BUSINESS INTERRUPTION) OR ARISING IN ANY WAY OUT OF THE USE, 
 * REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE NVIDIA SOFTWARE, 
 * HOWEVER CAUSED AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING 
 * NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN IF NVIDIA HAS BEEN ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */ 


/* 
 * The following macro invocations define the supported CG basic data types.
 *
 * The macros have the form :
 *
 *   CG_DATATYPE_MACRO(name, compiler_name, nrows, ncols)
 *
 *     name          : The name of the data type.
 *     compiler_name : The name of the data type within the compiler syntax.
 *     nrows         : Number of rows for matrix types.  Should be 0 other-wise.
 *     ncols         : Number of columns for matrix types.  Should be 0 
 *                     other-wise.
 *   
 */



CG_DATATYPE_MACRO(Half,half,0,0)
CG_DATATYPE_MACRO(Half2,half2,0,0)
CG_DATATYPE_MACRO(Half3,half3,0,0)
CG_DATATYPE_MACRO(Half4,half4,0,0)
CG_DATATYPE_MACRO(Half1x1,half1x1,1,1)
CG_DATATYPE_MACRO(Half1x2,half1x2,1,2)
CG_DATATYPE_MACRO(Half1x3,half1x3,1,3)
CG_DATATYPE_MACRO(Half1x4,half1x4,1,4)
CG_DATATYPE_MACRO(Half2x1,half2x1,2,1)
CG_DATATYPE_MACRO(Half2x2,half2x2,2,2)
CG_DATATYPE_MACRO(Half2x3,half2x3,2,3)
CG_DATATYPE_MACRO(Half2x4,half2x4,2,4)
CG_DATATYPE_MACRO(Half3x1,half3x1,3,1)
CG_DATATYPE_MACRO(Half3x2,half3x2,3,2)
CG_DATATYPE_MACRO(Half3x3,half3x3,3,3)
CG_DATATYPE_MACRO(Half3x4,half3x4,3,4)
CG_DATATYPE_MACRO(Half4x1,half4x1,4,1)
CG_DATATYPE_MACRO(Half4x2,half4x2,4,2)
CG_DATATYPE_MACRO(Half4x3,half4x3,4,3)
CG_DATATYPE_MACRO(Half4x4,half4x4,4,4)
CG_DATATYPE_MACRO(Float,float,0,0)
CG_DATATYPE_MACRO(Float2,float2,0,0)
CG_DATATYPE_MACRO(Float3,float3,0,0)
CG_DATATYPE_MACRO(Float4,float4,0,0)
CG_DATATYPE_MACRO(Float1x1,float1x1,1,1)
CG_DATATYPE_MACRO(Float1x2,float1x2,1,2)
CG_DATATYPE_MACRO(Float1x3,float1x3,1,3)
CG_DATATYPE_MACRO(Float1x4,float1x4,1,4)
CG_DATATYPE_MACRO(Float2x1,float2x1,2,1)
CG_DATATYPE_MACRO(Float2x2,float2x2,2,2)
CG_DATATYPE_MACRO(Float2x3,float2x3,2,3)
CG_DATATYPE_MACRO(Float2x4,float2x4,2,4)
CG_DATATYPE_MACRO(Float3x1,float3x1,3,1)
CG_DATATYPE_MACRO(Float3x2,float3x2,3,2)
CG_DATATYPE_MACRO(Float3x3,float3x3,3,3)
CG_DATATYPE_MACRO(Float3x4,float3x4,3,4)
CG_DATATYPE_MACRO(Float4x1,float4x1,4,1)
CG_DATATYPE_MACRO(Float4x2,float4x2,4,2)
CG_DATATYPE_MACRO(Float4x3,float4x3,4,3)
CG_DATATYPE_MACRO(Float4x4,float4x4,4,4)
CG_DATATYPE_MACRO(Sampler1D,sampler1D,0,0)
CG_DATATYPE_MACRO(Sampler2D,sampler2D,0,0)
CG_DATATYPE_MACRO(Sampler3D,sampler3D,0,0)
CG_DATATYPE_MACRO(SamplerRECT,samplerRECT,0,0)
CG_DATATYPE_MACRO(SamplerCUBE,samplerCUBE,0,0)

#undef CG_DATATYPE_MACRO


