/*
 *
 * Copyright (c) 2002, NVIDIA Corporation.
 * 
 *  
 * 
 * NVIDIA Corporation("NVIDIA") supplies this software to you in consideration 
 * of your agreement to the following terms, and your use, installation, 
 * modification or redistribution of this NVIDIA software constitutes 
 * acceptance of these terms.  If you do not agree with these terms, please do 
 * not use, install, modify or redistribute this NVIDIA software.
 * 
 *  
 * 
 * In consideration of your agreement to abide by the following terms, and 
 * subject to these terms, NVIDIA grants you a personal, non-exclusive license,
 * under NVIDIAs copyrights in this original NVIDIA software (the "NVIDIA 
 * Software"), to use, reproduce, modify and redistribute the NVIDIA 
 * Software, with or without modifications, in source and/or binary forms; 
 * provided that if you redistribute the NVIDIA Software, you must retain the 
 * copyright notice of NVIDIA, this notice and the following text and 
 * disclaimers in all such redistributions of the NVIDIA Software. Neither the 
 * name, trademarks, service marks nor logos of NVIDIA Corporation may be used 
 * to endorse or promote products derived from the NVIDIA Software without 
 * specific prior written permission from NVIDIA.  Except as expressly stated 
 * in this notice, no other rights or licenses express or implied, are granted 
 * by NVIDIA herein, including but not limited to any patent rights that may be 
 * infringed by your derivative works or by other works in which the NVIDIA 
 * Software may be incorporated. No hardware is licensed hereunder. 
 * 
 *  
 * 
 * THE NVIDIA SOFTWARE IS BEING PROVIDED ON AN "AS IS" BASIS, WITHOUT 
 * WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING 
 * WITHOUT LIMITATION, WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR ITS USE AND OPERATION 
 * EITHER ALONE OR IN COMBINATION WITH OTHER PRODUCTS.
 * 
 *  
 * 
 * IN NO EVENT SHALL NVIDIA BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL, 
 * EXEMPLARY, CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, LOST 
 * PROFITS; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
 * PROFITS; OR BUSINESS INTERRUPTION) OR ARISING IN ANY WAY OUT OF THE USE, 
 * REPRODUCTION, MODIFICATION AND/OR DISTRIBUTION OF THE NVIDIA SOFTWARE, 
 * HOWEVER CAUSED AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING 
 * NEGLIGENCE), STRICT LIABILITY OR OTHERWISE, EVEN IF NVIDIA HAS BEEN ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */ 

/* 
 * The following macro invocations define error codes returned by various cg 
 * API functions.
 *
 * The macros have the form :
 *
 *   CG_ERROR_MACRO(code, enum_name, message)
 *
 *     code      : The integer error code associated with the error.
 *     enum_name : The name of enumerant of the error code.  
 *                  (Note : the prefix "cg" will be added to the name).
 *     message   : A description string associated with the error.
 *   
 */


CG_ERROR_MACRO(0, 
               NoError,
               "No error has occurred.")

CG_ERROR_MACRO(1, 
               CompileError, 
               "The compile returned an error.")

CG_ERROR_MACRO(2, 
               InvalidParameterError,
               "The parameter used is of invalid type.")

CG_ERROR_MACRO(3, 
               InvalidProfileError, 
               "The profile is not supported.")

CG_ERROR_MACRO(4, 
               ProgramLoadError,
               "The program did could not load.")

CG_ERROR_MACRO(5, 
               ProgramBindError, 
               "The program could not bind.")

CG_ERROR_MACRO(6, 
               ProgramNotLoadedError,
               "The program must be loaded before this operation may be used.")

CG_ERROR_MACRO(7, 
               UnsupportedGLExtensionError,
               "An unsupported GL extension was required to perform this operation.")

CG_ERROR_MACRO(8, 
               InvalidValueTypeError,
               "An unknown value type was assigned to a parameter.")

CG_ERROR_MACRO(9, 
               NotMatrixParamError,
               "The parameter is not of matrix type.")

CG_ERROR_MACRO(10, 
               InvalidEnumerantError,
               "The enumerant parameter has an invalid value.")

CG_ERROR_MACRO(11, 
               Not4x4MatrixError,
               "The parameter must be a 4x4 matrix type.")

CG_ERROR_MACRO(12, 
               FileReadError,
               "The could not be read.")

CG_ERROR_MACRO(13, 
               FileWriteError,
               "The could not be written.")

#undef CG_ERROR_MACRO

