using System;

namespace Exocortex.OpenGL {

	//////////////////////////////////////////////////////////////////////////////////////
	
	public enum GLPolygonFaces : uint {
		Front			= GL.GL_FRONT,
		Back			= GL.GL_BACK,
		FrontAndBack	= GL.GL_FRONT_AND_BACK,
	}
	public enum GLPolygonMode : uint {
		Point	= GL.GL_POINT,
		Line	= GL.GL_LINE,
		Fill	= GL.GL_FILL,
	}

	public enum GLOption : uint {
		AlphaTest			=  GL.GL_ALPHA_TEST,		// If enabled, do alpha testing. See glAlphaFunc. 
		AutoNormal			=  GL.GL_AUTO_NORMAL,		// If enabled, compute surface normal vectors analytically when either GL_MAP2_VERTEX_3 or GL_MAP2_VERTEX_4 has generated vertices. See glMap2.  
		Blend				=  GL.GL_BLEND,			// If enabled, blend the incoming RGBA color values with the values in the color buffers. See glBlendFunc. 
		ClipPlane0			=  GL.GL_CLIP_PLANE0,		// If enabled, clip geometry against user-defined clipping plane 0. See glClipPlane.  
		ClipPlane1			=  GL.GL_CLIP_PLANE1,		// If enabled, clip geometry against user-defined clipping plane 1. See glClipPlane.  
		ClipPlane2			=  GL.GL_CLIP_PLANE2,		// If enabled, clip geometry against user-defined clipping plane 2. See glClipPlane.  
		ClipPlane3			=  GL.GL_CLIP_PLANE3,		// If enabled, clip geometry against user-defined clipping plane 3. See glClipPlane.  
		ClipPlane4			=  GL.GL_CLIP_PLANE4,		// If enabled, clip geometry against user-defined clipping plane 4. See glClipPlane.  
		ClipPlane5			=  GL.GL_CLIP_PLANE5,		// If enabled, clip geometry against user-defined clipping plane 5. See glClipPlane.  
		ColorLogicOp		=  GL.GL_COLOR_LOGIC_OP,	// If enabled, apply the current logical operation to the incoming RGBA color and color buffer values. See glLogicOp. 
		ColorMaterial		=  GL.GL_COLOR_MATERIAL,	// If enabled, have one or more material parameters track the current color. See glColorMaterial.  
		CullFace			=  GL.GL_CULL_FACE,		// If enabled, cull polygons based on their winding in window coordinates. See glCullFace. 
		DepthTest			=  GL.GL_DEPTH_TEST,		// If enabled, do depth comparisons and update the depth buffer. See glDepthFunc and glDepthRange. 
		Dither				=  GL.GL_DITHER,			// If enabled, dither color components or indexes before they are written to the color buffer.  
		Fog					=  GL.GL_FOG,				// If enabled, blend a fog color into the post-texturing color. See glFog. 
		IndexLogicOp		=  GL.GL_INDEX_LOGIC_OP,	// If enabled, apply the current logical operation to the incoming index and color buffer indices. See glLogicOp. 
		Light0				=  GL.GL_LIGHT0,			// If enabled, include light 0 in the evaluation of the lighting equation. See glLightModel and glLight. 
		Light1				=  GL.GL_LIGHT1,			// If enabled, include light 1 in the evaluation of the lighting equation. See glLightModel and glLight. 
		Light2				=  GL.GL_LIGHT2,			// If enabled, include light 2 in the evaluation of the lighting equation. See glLightModel and glLight. 
		Light3				=  GL.GL_LIGHT3,			// If enabled, include light 3 in the evaluation of the lighting equation. See glLightModel and glLight. 
		Light4				=  GL.GL_LIGHT4,			// If enabled, include light 4 in the evaluation of the lighting equation. See glLightModel and glLight. 
		Light5				=  GL.GL_LIGHT5,			// If enabled, include light 5 in the evaluation of the lighting equation. See glLightModel and glLight. 
		Light6				=  GL.GL_LIGHT6,			// If enabled, include light 6 in the evaluation of the lighting equation. See glLightModel and glLight. 
		Light7				=  GL.GL_LIGHT7,			// If enabled, include light 7 in the evaluation of the lighting equation. See glLightModel and glLight. 
		Lighting			=  GL.GL_LIGHTING,			// If enabled, use the current lighting parameters to compute the vertex color or index. If disabled, associate the current color or index with each vertex. See glMaterial, glLightModel, and glLight.
		LineSmooth			=  GL.GL_LINE_SMOOTH,		// If enabled, draw lines with correct filtering. If disabled, draw aliased lines. See glLineWidth. 
		LineStipple			=  GL.GL_LINE_STIPPLE,		// If enabled, use the current line stipple pattern when drawing lines. See glLineStipple.  
		LogicOp				=  GL.GL_LOGIC_OP,			// If enabled, apply the currently selected logical operation to the incoming and color-buffer indexes. See glLogicOp.  
		PolygonOffsetFill	=  GL.GL_POLYGON_OFFSET_FILL,	// If enabled, and if the polygon is rendered in GL_FILL mode, an offset is added to depth values of a polygon's fragments before the depth comparison is performed. See glPolygonOffset. 
		PolygonOffsetLine	=  GL.GL_POLYGON_OFFSET_LINE,	// If enabled, and if the polygon is rendered in GL_LINE mode, an offset is added to depth values of a polygon's fragments before the depth comparison is performed. See glPolygonOffset. 
		PolygonOffsetPoint	=  GL.GL_POLYGON_OFFSET_POINT,	// If enabled, an offset is added to depth values of a polygon's fragments before the depth comparison is performed, if the polygon is rendered in GL_POINT mode. See glPolygonOffset. 
		PolygonSmooth		=  GL.GL_POLYGON_SMOOTH,		// If enabled, draw polygons with proper filtering. If disabled, draw aliased polygons. See glPolygonMode. 
		PolygonStipple	=  GL.GL_POLYGON_STIPPLE,			// If enabled, use the current polygon stipple pattern when rendering polygons. See glPolygonStipple.  
		PointSmooth			=  GL.GL_POINT_SMOOTH,			// If enabled, draw points with proper filtering. If disabled, draw aliased points. See glPointSize. 
		Map1Color4			=  GL.GL_MAP1_COLOR_4,			// If enabled, calls to glEvalCoord1, glEvalMesh1, and glEvalPoint1 generate RGBA values. See also glMap1.  
		Map1Index			=  GL.GL_MAP1_INDEX,			// If enabled, calls to glEvalCoord1, glEvalMesh1, and glEvalPoint1 generate color indexes. See also glMap1.  
		Map1Normal			=  GL.GL_MAP1_NORMAL,			// If enabled, calls to glEvalCoord1, glEvalMesh1, and glEvalPoint1 generate normals. See also glMap1.  
		Map1TextureCoord1	=  GL.GL_MAP1_TEXTURE_COORD_1,	// If enabled, calls to glEvalCoord1, glEvalMesh1, and glEvalPoint1 generate s texture coordinates. See also glMap1.  
		Map1TextureCoord2	=  GL.GL_MAP1_TEXTURE_COORD_2,	// If enabled, calls to glEvalCoord1, glEvalMesh1, and glEvalPoint1 generate s and t texture coordinates. See also glMap1.  
		Map1TextureCoord3	=  GL.GL_MAP1_TEXTURE_COORD_3,	// If enabled, calls to glEvalCoord1, glEvalMesh1, and glEvalPoint1 generate s, t, and r texture coordinates. See also glMap1.  
		Map1TextureCoord4	=  GL.GL_MAP1_TEXTURE_COORD_4,	// If enabled, calls to glEvalCoord1, glEvalMesh1, and glEvalPoint1 generate s, t, r, and q texture coordinates. See also glMap1.  
		Map1Vertex3			=  GL.GL_MAP1_VERTEX_3,		// If enabled, calls to glEvalCoord1, glEvalMesh1, and glEvalPoint1 generate x, y, and z vertex coordinates. See also glMap1.  
		Map1Vertex4			=  GL.GL_MAP1_VERTEX_4,		// If enabled, calls to glEvalCoord1, glEvalMesh1, and glEvalPoint1 generate homogeneous x, y, z, and w vertex coordinates. See also glMap1.  
		Map2Color4			=  GL.GL_MAP2_COLOR_4,			// If enabled, calls to glEvalCoord2, glEvalMesh2, and glEvalPoint2 generate RGBA values. See also glMap2.  
		Map2Index			=  GL.GL_MAP2_INDEX,			// If enabled, calls to glEvalCoord2, glEvalMesh2, and glEvalPoint2 generate color indexes. See also glMap2.  
		Map2Normal			=  GL.GL_MAP2_NORMAL,			// If enabled, calls to glEvalCoord2, glEvalMesh2, and glEvalPoint2 generate normals. See also glMap2.  
		Map2TextureCoord1	=  GL.GL_MAP2_TEXTURE_COORD_1,	// If enabled, calls to glEvalCoord2, glEvalMesh2, and glEvalPoint2 generate s texture coordinates. See also glMap2.  
		Map2TextureCoord2	=  GL.GL_MAP2_TEXTURE_COORD_2,	// If enabled, calls to glEvalCoord2, glEvalMesh2, and glEvalPoint2 generate s and t texture coordinates. See also glMap2.  
		Map2TextureCoord3	=  GL.GL_MAP2_TEXTURE_COORD_3,	// If enabled, calls to glEvalCoord2, glEvalMesh2, and glEvalPoint2 generate s, t, and r texture coordinates. See also glMap2.  
		Map2TextureCoord4	=  GL.GL_MAP2_TEXTURE_COORD_4,	// If enabled, calls to glEvalCoord2, glEvalMesh2, and glEvalPoint2 generate s, t, r, and q texture coordinates. See also glMap2.  
		Map2Vertex3			=  GL.GL_MAP2_VERTEX_3,		// If enabled, calls to glEvalCoord2, glEvalMesh2, and glEvalPoint2 generate x, y, and z vertex coordinates. See also glMap2.  
		Map2Vertex4			=  GL.GL_MAP2_VERTEX_4,		// If enabled, calls to glEvalCoord2, glEvalMesh2, and glEvalPoint2 generate homogeneous x, y, z, and w vertex coordinates. See also glMap2.  
		Normalize			=  GL.GL_NORMALIZE,		// If enabled, normal vectors specified with glNormal are scaled to unit length after transformation. See glNormal. 
		ScissorTest			=  GL.GL_SCISSOR_TEST,		// If enabled, discard fragments that are outside the scissor rectangle. See glScissor.
		StencilTest			=  GL.GL_STENCIL_TEST,		// If enabled, do stencil testing and update the stencil buffer. See glStencilFunc and glStencilOp.
		Texture1D			=  GL.GL_TEXTURE_1D,		// If enabled, one-dimensional texturing is performed (unless two-dimensional texturing is also enabled). See glTexImage1D. 
		Texture2D			=  GL.GL_TEXTURE_2D,		// If enabled, two-dimensional texturing is performed. See glTexImage2D.
		TextureGenQ			=  GL.GL_TEXTURE_GEN_Q,	// If enabled, the q texture coordinate is computed using the texture-generation function defined with glTexGen. Otherwise, the current q texture coordinate is used.
		TextureGenR			=  GL.GL_TEXTURE_GEN_R,	// If enabled, the r texture coordinate is computed using the texture generation function defined with glTexGen. If disabled, the current r texture coordinate is used.  
		TextureGenS			=  GL.GL_TEXTURE_GEN_S,	// If enabled, the s texture coordinate is computed using the texture generation function defined with glTexGen. If disabled, the current s texture coordinate is used.  
		TextureGenT			=  GL.GL_TEXTURE_GEN_T,	// If enabled, the t texture coordinate is computed using the texture generation function defined with glTexGen. If disabled, the current t texture coordinate is used.  
	}

	///////////////////////////////////////////////////////////////////////////////////

	public enum GLAlphaFunc : uint {
		Never			=  GL.GL_NEVER,	// Never passes.  
		Less			=  GL.GL_LESS,		// Passes if the incoming alpha value is less than the reference value.  
		Equal			=  GL.GL_EQUAL,		// Passes if the incoming alpha value is equal to the reference value.  
		LessOrEqual		=  GL.GL_LEQUAL,		// Passes if the incoming alpha value is less than or equal to the reference value.  
		Greater			=  GL.GL_GREATER,		//  Passes if the incoming alpha value is greater than the reference value.  
		NotEqual		=  GL.GL_NOTEQUAL,	// Passes if the incoming alpha value is not equal to the reference value.  
		GreaterOrEqual	=  GL.GL_GEQUAL,		// Passes if the incoming alpha value is greater than or equal to the reference value.  
		Always			=  GL.GL_ALWAYS,		// Always passes. This is the default. 
	}

	///////////////////////////////////////////////////////////////////////////////////
	
	public enum GLTexture : uint {
		Texture1D	=  GL.GL_TEXTURE_1D,
		Texture2D	=  GL.GL_TEXTURE_2D
	}
	
	///////////////////////////////////////////////////////////////////////////////////

	public enum GLTexEnvTarget : uint {
		TextureEnv	=  GL.GL_TEXTURE_ENV 
	}

	public enum GLTexEnvPName : uint {
		TextureEnvMode	=  GL.GL_TEXTURE_ENV_MODE 
	}
			
	public enum GLTexEnvParam : uint {
		Modulate	=  GL.GL_MODULATE,
		Decal		=  GL.GL_DECAL,
		Blend		=  GL.GL_BLEND,
		Replace		=  GL.GL_REPLACE
	}

	///////////////////////////////////////////////////////////////////////////////////

	public enum GLTexParamPName : uint {
		TextureMinFilter	=  GL.GL_TEXTURE_MIN_FILTER, 
		TextureMagFilter	=  GL.GL_TEXTURE_MAG_FILTER,  
		TextureWrapS		=  GL.GL_TEXTURE_WRAP_S, 
		TextureWrapT		=  GL.GL_TEXTURE_WRAP_T,
		TextureBorderColor	=  GL.GL_TEXTURE_BORDER_COLOR, 
		TexturePriority		=  GL.GL_TEXTURE_PRIORITY,
	}
				
	public enum GLTextureFilter : uint {
		Nearest					= 	GL.GL_NEAREST,
		Linear					=  GL.GL_LINEAR,
		NearestMipmapNearest	=  GL.GL_NEAREST_MIPMAP_NEAREST,
		LinearMipmapNearest		=  GL.GL_LINEAR_MIPMAP_NEAREST,
		NearestMipmapLinear		=  GL.GL_NEAREST_MIPMAP_LINEAR,
		LinearMipmapLinear		=  GL.GL_LINEAR_MIPMAP_LINEAR,
	}

	///////////////////////////////////////////////////////////////////////////////////

	public enum GLPrimative : uint {
		Points			=  GL.GL_POINTS,
		Lines			=  GL.GL_LINES,
		Polygon			=  GL.GL_POLYGON,
		Triangles		=  GL.GL_TRIANGLES,
		Quads			=  GL.GL_QUADS,
		LineStrip		=  GL.GL_LINE_STRIP,
		LineLoop		=  GL.GL_LINE_LOOP,
		TriangleStrip	=  GL.GL_TRIANGLE_STRIP,
		TriangleFan		=  GL.GL_TRIANGLE_FAN,
		QuadStrip		=  GL.GL_QUAD_STRIP
	}

	///////////////////////////////////////////////////////////////////////////////////

	public enum GLHint : uint {
		PointSmooth		=  GL.GL_POINT_SMOOTH_HINT,
		LineSmooth		=  GL.GL_LINE_SMOOTH_HINT,
		PolygonSmooth	=  GL.GL_POLYGON_SMOOTH_HINT,
		Fog				=  GL.GL_FOG_HINT,
		PerspectiveCorrection =  GL.GL_PERSPECTIVE_CORRECTION_HINT
	}
	public enum GLQuality : uint {
		Fastest		=  GL.GL_FASTEST,
		Nicest		=  GL.GL_NICEST,
		DontCare	=  GL.GL_DONT_CARE
	}
			
	///////////////////////////////////////////////////////////////////////////////////
		
	public enum GLMatrixMode : uint {
		Projection	=  GL.GL_PROJECTION,
		ModelView	=  GL.GL_MODELVIEW,
		Texture		=  GL.GL_TEXTURE
	}

	///////////////////////////////////////////////////////////////////////////////////
		
	public enum GLBuffers : uint {
		Color	=  GL.GL_COLOR_BUFFER_BIT,
		Depth	=  GL.GL_DEPTH_BUFFER_BIT,
		Accum	=  GL.GL_ACCUM_BUFFER_BIT,
		Stencil	=  GL.GL_STENCIL_BUFFER_BIT
	}
	
	///////////////////////////////////////////////////////////////////////////////////

	public enum GLDepthFunc : uint {
		Less			=  GL.GL_LESS,
		LessOrEqual		=  GL.GL_LEQUAL,
		Equal			=  GL.GL_EQUAL,
		GreaterOrEqual	=  GL.GL_GEQUAL,
		Greater			=  GL.GL_GREATER
	}

	///////////////////////////////////////////////////////////////////////////////////
		
	public enum GLShadeModel : uint {
		Smooth		=  GL.GL_SMOOTH,
		Flat		=  GL.GL_FLAT,
	}
			
	///////////////////////////////////////////////////////////////////////////////////

	public enum GLBlendSrc : uint {
		Zero				=  GL.GL_ZERO,
		One					=  GL.GL_ONE, 
		DestColor			=  GL.GL_DST_COLOR, 
		OneMinusDestColor	=  GL.GL_ONE_MINUS_DST_COLOR, 
		SrcAlpha			=  GL.GL_SRC_ALPHA, 
		OneMinusSrcAlpha	=  GL.GL_ONE_MINUS_SRC_ALPHA, 
		DestAlpha			=  GL.GL_DST_ALPHA, 
		OneMinusDestAlpha	=  GL.GL_ONE_MINUS_DST_ALPHA,
		SrcAlphaSaturate	=  GL.GL_SRC_ALPHA_SATURATE
	}

	public enum GLBlendDest : uint {
		Zero				=  GL.GL_ZERO,
		One					=  GL.GL_ONE,
		SrcAlpha			=  GL.GL_SRC_ALPHA,
		OneMinusSrcAlpha	=  GL.GL_ONE_MINUS_SRC_ALPHA, 
		DestAlpha			=  GL.GL_DST_ALPHA, 
		OneMinusDestAlpha	=  GL.GL_ONE_MINUS_DST_ALPHA, 
		SrcColor			=  GL.GL_SRC_COLOR, 
		OneMinusSrcColor	=  GL.GL_ONE_MINUS_SRC_COLOR 
	}

	public enum GLInternalFormat : uint {
		One		=  1,
		Two		=  2,
		Three	=  3,
		Four	=  4,

		Alpha		=  GL.GL_ALPHA,
		Alpha4		=  GL.GL_ALPHA4,
		Alpha8		=  GL.GL_ALPHA8,
		Alpha12		=  GL.GL_ALPHA12,
		Alpha16		=  GL.GL_ALPHA16,
		Luminance		=  GL.GL_LUMINANCE,
		Luminance4		=  GL.GL_LUMINANCE4,
		Luminance8		=  GL.GL_LUMINANCE8,
		Luminance12		=  GL.GL_LUMINANCE12,
		Luminance16		=  GL.GL_LUMINANCE16,
		Luminance_Alpha		=  GL.GL_LUMINANCE_ALPHA,
		Luminance4_Alpha4	=  GL.GL_LUMINANCE4_ALPHA4,
		Luminance6_Alpha2	=  GL.GL_LUMINANCE6_ALPHA2, 
		Luminance8_Alpha8	=  GL.GL_LUMINANCE8_ALPHA8, 
		Luminance12_Alpha4	=  GL.GL_LUMINANCE12_ALPHA4, 
		Luminance12_Alpha12	=  GL.GL_LUMINANCE12_ALPHA12, 
		Luminance16_Alpha16	=  GL.GL_LUMINANCE16_ALPHA16, 
		Intensity		=  GL.GL_INTENSITY,
		Intensity4		=  GL.GL_INTENSITY4, 
		Intensity8		=  GL.GL_INTENSITY8, 
		Intensity12		=  GL.GL_INTENSITY12, 
		Intensity16		=  GL.GL_INTENSITY16, 
		R3G3B2	=  GL.GL_R3_G3_B2,
		RGB		=  GL.GL_RGB,
		RGB4	=  GL.GL_RGB4,
		RGB5	=  GL.GL_RGB5,
		RGB8	=  GL.GL_RGB8,
		RGB10	=  GL.GL_RGB10,
		RGB12	=  GL.GL_RGB12,
		RGB16	=  GL.GL_RGB16, 
		RGBA	=  GL.GL_RGBA, 
		RGBA2	=  GL.GL_RGBA2, 
		RGBA4	=  GL.GL_RGBA4, 
		RGB5_A1		=  GL.GL_RGB5_A1, 
		RGBA8		=  GL.GL_RGBA8, 
		RGBA12		=  GL.GL_RGBA12, 
		RGB10_A2	=  GL.GL_RGB10_A2, 
		RGBA16		=  GL.GL_RGBA16
	}

	public enum GLPixelFormat : uint {
		ColorIndex	=  GL.GL_COLOR_INDEX,
		Red		=  GL.GL_RED,
		Green	=  GL.GL_GREEN,
		Blue	=  GL.GL_BLUE,
		Alpha	=  GL.GL_ALPHA,
		RGB		=  GL.GL_RGB,
		RGBA	=  GL.GL_RGBA,
		BGRExt		=  GL.GL_BGR_EXT,
		BGRAExt		=  GL.GL_BGRA_EXT,
		Luminance		=  GL.GL_LUMINANCE,
		LuminanceAlpha	=  GL.GL_LUMINANCE_ALPHA
	}

	public enum GLDataType : uint {
		UnsignedByte	=  GL.GL_UNSIGNED_BYTE,
		Byte			=  GL.GL_BYTE,
		Bitmap			=  GL.GL_BITMAP,
		UnsignedShort	=  GL.GL_UNSIGNED_SHORT,
		Short			=  GL.GL_SHORT,
		UnsignedInt		=  GL.GL_UNSIGNED_INT, 
		Int				=  GL.GL_INT,
		Float			=  GL.GL_FLOAT
	}

	public enum	GLUnsignedDataType : uint {
		UnsignedByte	= GL.GL_UNSIGNED_BYTE,
		UnsignedShort	= GL.GL_UNSIGNED_SHORT,
		UnsignedInt		= GL.GL_UNSIGNED_INT
	}

	public enum GLPixelStore : uint {
		PackSwapBytes		=  GL.GL_PACK_SWAP_BYTES,
		PackRowLength		=  GL.GL_PACK_ROW_LENGTH,
		PackSkipRows		=  GL.GL_PACK_SKIP_ROWS,
		PackSkipPixels		=  GL.GL_PACK_SKIP_PIXELS,
		PackAlignment		=  GL.GL_PACK_ALIGNMENT,
		UnpackSwapBytes		=  GL.GL_UNPACK_SWAP_BYTES,
		UnpackLSBFirst		=  GL.GL_UNPACK_LSB_FIRST,
		UnpackRowLength		=  GL.GL_UNPACK_ROW_LENGTH,
		UnpackSkipRows		=  GL.GL_UNPACK_SKIP_ROWS,
		UnpackSkipPixels	=  GL.GL_UNPACK_SKIP_PIXELS,
		UnpackAlighment		=  GL.GL_UNPACK_ALIGNMENT,
	}


}
