using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Data;
using System.Windows.Forms;

namespace Exocortex.Windows.Forms
{
	/// <summary>
	/// Summary description for BitmapBox.
	/// </summary>
	public class PictureBoxEx : System.Windows.Forms.UserControl
	{
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public PictureBoxEx()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

		    this.SetStyle( ControlStyles.ResizeRedraw, true );
			this.SetStyle( ControlStyles.AllPaintingInWmPaint, true );
			this.SetStyle( ControlStyles.DoubleBuffer, true );
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			components = new System.ComponentModel.Container();
		}
		#endregion

		protected Image	_image = null;
		public	Image	Image {
			get	{	return	_image;	}
			set {
				if( _image == value ) {
					return;
				}
				_image = value;
				this.Invalidate();
			}
		}

		protected InterpolationMode _interpolationMode = InterpolationMode.Default;
		public InterpolationMode InterpolationMode {
			get	{	return	 _interpolationMode;	}
			set {
				if( _interpolationMode == value ) {
					return;
				}
				_interpolationMode = value;
				this.Invalidate();
			}
		}

		protected override void OnPaint( PaintEventArgs e ) {
			//Debug2.Push();
			
			Graphics g = e.Graphics;
			if( _image != null ) {
				//g.Clear( Color.YellowGreen );
				g.InterpolationMode = _interpolationMode;
				g.DrawImage( _image, 0, 0, this.Width, this.Height );
			}
			else {
				g.Clear( this.BackColor );
			}

			//Debug2.Pop();
		}
	}
}
